from django.contrib.auth import authenticate, login, logout
from django.db import IntegrityError
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse
from django.core.files import File
from django.core.files.temp import NamedTemporaryFile
from django.core.files.base import ContentFile
import requests
from .models import User,AuctionListing,Comments


def index(request):
    listings = AuctionListing.objects.all()
    
    return render(request, "auctions/index.html",{
        "Listings":listings
    })
    
def listing(request,title):
    """
    docstring
    """
    listing = AuctionListing.objects.get(title)
    return render(request,"acutions/listing.html",{
        "Listing": listing
    })

def login_view(request):
    if request.method == "POST":

        # Attempt to sign user in
        username = request.POST["username"]
        password = request.POST["password"]
        user = authenticate(request, username=username, password=password)

        # Check if authentication successful
        if user is not None:
            login(request, user)
            return HttpResponseRedirect(reverse("index"))
        else:
            return render(request, "auctions/login.html", {
                "message": "Invalid username and/or password."
            })
    else:
        return render(request, "auctions/login.html")


def logout_view(request):
    logout(request)
    return HttpResponseRedirect(reverse("index"))


def register(request):
    if request.method == "POST":
        username = request.POST["username"]
        email = request.POST["email"]

        # Ensure password matches confirmation
        password = request.POST["password"]
        confirmation = request.POST["confirmation"]
        if password != confirmation:
            return render(request, "auctions/register.html", {
                "message": "Passwords must match."
            })

        # Attempt to create new user
        try:
            user = User.objects.create_user(username, email, password)
            user.save()
        except IntegrityError:
            return render(request, "auctions/register.html", {
                "message": "Username already taken."
            })
        login(request, user)
        return HttpResponseRedirect(reverse("index"))
    else:
        return render(request, "auctions/register.html")
def create(request):
    """
    docstring
    """
    if request.method == "POST": 
        title = request.POST["title"] 
        desc = request.POST["desc"] 
        starting_bid = request.POST["starting_bid"]
        photo_url = request.POST["photo"]
        obj = AuctionListing(title = title, desc = desc, user = request.user,price = starting_bid, picture = photo_url)
        obj.save()
        return render(request,"auctions/index.html")
    else:    
        return render(request,"auctions/create_listing.html")
